clear all
close all
% u''(x)+u'(x)+u(x)-cos(x)=0
% u(0)=0
% u(pi/2)=1
% elementi finiti
a = 0;
b = pi/2;
mrif = 1001;
m = mrif;
x = linspace(a,b,mrif)';
h = diff(x);
A = spdiags([[-1./h(1:m-1);0],...
	     [1/h(1);1./h(1:m-2)+1./h(2:m-1);1/h(m-1)],...
	     [0;-1./h(1:m-1)]],[-1:1],m,m);
B = spdiags([-ones(m,1)/2,ones(m,1)/2],[-1,1],m,m);
C = spdiags([[h(1:m-1)/6;0],...
	       [h(1)/3;h(1:m-2)/3+h(2:m-1)/3;h(m-1)/3],...
	       [0;h(1:m-1)/6]],[-1:1],m,m);
M = -A+B+C;
M(1,1) = 1/h(1);
M(1,2) = 0;
M(m,m-1) = 0;
M(m,m) = 1/h(m-1);
rhs = cos(x).*[h(1)/2;(h(1:m-2)+h(2:m-1))/2;h(m-1)/2];
rhs(1) = 0;
rhs(m) = 1/h(m-1);
urif = M\rhs;
mrange = [21,51,101];
counter = 0;
for m = mrange
  counter = counter+1;
  x = linspace(a,b,m)';
  h = diff(x);
  A = spdiags([[-1./h(1:m-1);0],...
	       [1/h(1);1./h(1:m-2)+1./h(2:m-1);1/h(m-1)],...
	       [0;-1./h(1:m-1)]],[-1:1],m,m);
  B = spdiags([-ones(m,1)/2,ones(m,1)/2],[-1,1],m,m);
  C = spdiags([[h(1:m-1)/6;0],...
	       [h(1)/3;h(1:m-2)/3+h(2:m-1)/3;h(m-1)/3],...
	       [0;h(1:m-1)/6]],[-1:1],m,m);
  M = -A+B+C;
  M(1,1) = 1/h(1);
  M(1,2) = 0;
  M(m,m-1) = 0;
  M(m,m) = 1/h(m-1);
  rhs = cos(x).*[h(1)/2;(h(1:m-2)+h(2:m-1))/2;h(m-1)/2];
  rhs(1) = 0;
  rhs(m) = 1/h(1);
  u = M\rhs;
  err(counter) = norm(u-urif(1:(mrif-1)/(m-1):mrif),Inf);
end
loglog(mrange,err,'*',mrange,err(1)*(mrange/mrange(1)).^(-2))
legend('errore','ordine 2')

