clear all
close all
% -((1+x)u'(x))'=1
% u(0)=0
% u(1)=0
% differenze finite
exact = @(x) -(x-log(x+1)/log(2));
a = 0;
b = 1;
mrange = 50:10:100;
counter = 0;
for m = mrange
  counter = counter+1;
  x = linspace(a,b,m)';
  h = diff(x);
  A = spdiags([[-(2+x(1:m-1)+x(2:m))./h(1:m-1)/2;0],...
	       [(2+x(1)+x(2))/h(1)/2;...
		(2+x(1:m-2)+x(2:m-1))./h(1:m-2)/2+(2+x(2:m-1)+x(3:m))./h(2:m-1)/2;...
		(2+x(m-1)+x(m))/h(m-1)/2],...
	       [0;-(2+x(1:m-1)+x(2:m))./h(1:m-1)/2]],[-1:1],m,m);
  M = A;
  M(1,1) = 1/h(1);
  M(1,2) = 0;
  M(m,m-1) = 0;
  M(m,m) = 1/h(m-1);
  rhs = [h(1)/2;(h(1:m-2)+h(2:m-1))/2;h(m-1)/2];;
  rhs(1) = 0;
  rhs(m) = 0;
  u = M\rhs;
  err(counter) = norm(u-exact(x),Inf);
end
loglog(mrange,err,'*',mrange,err(1)*(mrange/mrange(1)).^(-2))
legend('errore','ordine 2')

